
	import java.util.*;
	import java.applet.*;
	import java.awt.*; 
	import java.awt.event.*; 
	import java.util.Random;
	//import javax.swing.*;
	//I've just slapped something together for a connect 4 game.
	//It uses java.  It seems that java has a lot of different GUI systems.
	//I picked awt, and I got information from a book called Using java 2 Standard
	//Edition by Cavaness Friesen and Keeton.
	
	public class connectFour extends Applet 
	                         implements ActionListener {
		 
        // The board is numbered like  
		//   6 . . . . . . .
        //   5 . . . . . . .
        //   4 . . . . . . .
        //   3 . . . . . . .
        //   2 . . . . . . .
        //   1 . . . . . . .
        //     a b c d e f g
		//so, e.g. board[12] =c1 board[13] = c2

	private int board[];
	private int piecesInColumn[];
	private static final int blank = 0;
	private static final int playerX = 1;
	private static final int playerO = 2;
	private int currentPlayer = playerX;
	private boolean gameOver = false;
    //private Random randomGenerator;
	private Label turnLabel;

	private boolean agentPlaysO = true;
	private connectFourAgent playerOAgent;
	private boolean agentPlaysX = true;
	private connectFourAgent playerXAgent;
	

	//for application
	public static void main(String[] args) {
		System.out.println("Start Connect4 ");	
	}
	
	private int addToBoard(int player, int column) {
		if (piecesInColumn[column] == 6)
			return 0;
		
	    int newBoardCell = column*6;
	    newBoardCell += piecesInColumn[column];
	    piecesInColumn[column]++;
	    board [newBoardCell] = player;
		return 1;
	}
	
	public boolean verticalWin(int player) 
	{
		//check for vertical
		for (int col = 0; col < 7; col++)
			for (int rowStart = 0; rowStart < 2; rowStart++)
			{
				for (int checkRow=rowStart; checkRow<rowStart+4; checkRow++)
				{
					int square = col*6+checkRow;
					if (board[square] != player) break;
					if (checkRow == rowStart+3) return true;
				}
			}
		return false;
	}

	public boolean horizontalWin(int player) 
	{
		//check for horizontal
		for (int row = 0; row < 6; row++)
			for (int colStart = 0; colStart < 4; colStart++)
			{
				for (int checkCol=colStart; checkCol<colStart+4; checkCol++)
				{
					int square = checkCol*6+row;
					if (board[square] != player) break;
					if (checkCol == colStart+3) return true;
				}
			}
		return false;
	}
	
	public boolean slashWin(int player) 
	{
		//check for up right slash
		for (int col= 0; col < 4; col++)
			for (int rowStart = 0; rowStart < 3; rowStart++)
			{
				for (int offset = 0; offset <4; offset++)
				{
					int square = (col+offset)*6+(rowStart+offset);
					if (board[square] != player) break;
					if (offset == 3) return true;
				}
			}
			
		return false;
	}

	public boolean backSlashWin(int player) 
	{
		//check for up left slash
		for (int col= 3; col < 7; col++)
			for (int rowStart = 0; rowStart < 3; rowStart++)
			{
				for (int offset = 0; offset <4; offset++)
				{
					int square = (col-offset)*6+(rowStart+offset);
					if (board[square] != player) break;
					if (offset == 3) return true;
				}
			}
		return false;
	}

	public boolean checkForWin() {
		if (verticalWin(currentPlayer))
			return true;
		if (horizontalWin(currentPlayer))
			return true;
		if (slashWin(currentPlayer))
			return true;
		if (backSlashWin(currentPlayer))
			return true;

		return (false);

	}
	
	public boolean checkForDraw() {
		 for (int i = 0; i < 42 ; i++ ){
			 if (board[i] == blank) return false;
		 }
		return true;
	}
	
	public void startNewGame() {
		reset();
		repaint();
	}
	
	public void twoAgentGame() {
		System.out.println("Two Agent Game");
		while (!gameOver) {
			agentMove2(currentPlayer);
			if (checkForWin()) {
				gameOver = true;
				if (currentPlayer == playerX) {
					System.out.println("X wins");
					turnLabel.setText("X wins;  X starts");
				} else {
					System.out.println("O wins");
					turnLabel.setText("O wins;  X starts");
				}
				repaint();
				return;
			} else if (checkForDraw()) {
				gameOver = true;
				System.out.println("Draw");
				turnLabel.setText("Draw;  X starts");
				repaint();
				return;
			}
		}
	}
	
	public void actionPerformed (ActionEvent e){
		int result=0;
		
		String id = e.getActionCommand();
		if (id.equals("New Game")) {
		   startNewGame();
		   gameOver = false;
		   if ((agentPlaysX) && (agentPlaysO)) twoAgentGame();
		   else if (agentPlaysX) agentMove2(playerX);
		   return;
		}
		else if (gameOver) {
			System.out.println("Game Over");
			turnLabel.setText("Game Over: X Starts");
			repaint();
			return;
		}
		
		if (id.equals("C 1")) {
			   result = addToBoard(currentPlayer,0);
			}
		else if (id.equals("C 2")) {
			   result = addToBoard(currentPlayer,1);
			}
		else if (id.equals("C 3")) {
			   result = addToBoard(currentPlayer,2);
			}
		else if (id.equals("C 4")) {
			   result = addToBoard(currentPlayer,3);
			}
		else if (id.equals("C 5")) {
			   result = addToBoard(currentPlayer,4);
			}
		else if (id.equals("C 6")) {
			   result = addToBoard(currentPlayer,5);
			}
		else if (id.equals("C 7")) {
			   result = addToBoard(currentPlayer,6);
			}

		if (result == 1) {
			if (checkForWin())  {
				gameOver = true;
				if (currentPlayer == playerX) {
					System.out.println("X wins");
					turnLabel.setText("X wins;  X starts");
				}
				else { 
					System.out.println("O wins");
					turnLabel.setText("O wins;  X starts");
				}
				repaint();
				return;
			}
			else if (checkForDraw()) {
				gameOver = true;
				System.out.println("Draw");
				turnLabel.setText("Draw;  X starts");		
			}
			
			if (currentPlayer == playerX)
				currentPlayer = playerO;
			else currentPlayer = playerX;
		}
		
		//if ((currentPlayer == playerO) && agentPlaysO) agentMove(playerO);
		if ((currentPlayer == playerO) && agentPlaysO) agentMove2(playerO);
		if ((currentPlayer == playerX) && agentPlaysX) agentMove2(playerX);
		
		setPlayerText();
		repaint();
	}
	
	 private void reset () {
		 for (int i = 0; i < 42 ; i++ ){
			 board[i] = blank;
		 }
		 for (int i = 0; i < 7 ; i++ ){
			 piecesInColumn[i] = 0;
		 }
		 currentPlayer = playerX;
	 }
	 public void init() 
     { 
 		 System.out.println("Start Connect4 init");	
 		 
 		 playerOAgent = new connectFourAgent();
 		 playerXAgent = new connectFourAgent();
 		 
 		 //randomGenerator = new Random();

		 board = new int [42];
		 for (int i = 0; i < 42 ; i++ ){
			 board[i] = blank;
		 }
		 
    	 piecesInColumn = new int [7];
		 for (int i = 0; i < 7 ; i++ ){
			 piecesInColumn[i] = 0;
		 }
	 
		 setBackground(Color.cyan);
		 setSize(500,500);
		 //		 setLocation(50,50);
		 
		 //somewhere around 420 in CF&K
		 setLayout(null);
		 
		 Button newGame = new Button("New Game");
		 add (newGame);
		 newGame.setBounds(5,55,70,40);
		 newGame.addActionListener(this);

		 Button b1 = new Button("C 1");
		 add (b1);
		 b1.setBounds(105,55,40,40);
		 b1.addActionListener(this);
		 
		 Button b2 = new Button("C 2");
		 add (b2);
		 b2.setBounds(155,55,40,40);
		 b2.addActionListener(this);
		 
		 Button b3 = new Button("C 3");
		 add (b3);
		 b3.setBounds(205,55,40,40);
		 b3.addActionListener(this);
		 		 
		 Button b4 = new Button("C 4");
		 add (b4);
		 b4.setBounds(255,55,40,40);
		 b4.addActionListener(this);
		 
		 Button b5 = new Button("C 5");
		 add (b5);
		 b5.setBounds(305,55,40,40);
		 b5.addActionListener(this);
		 
		 Button b6 = new Button("C 6");
		 add (b6);
		 b6.setBounds(355,55,40,40);
		 b6.addActionListener(this);
		 
		 Button b7 = new Button("C 7");
		 add (b7);
		 b7.setBounds(405,55,40,40);
		 b7.addActionListener(this);

		 turnLabel = new Label();
		 turnLabel.setText("X starts");
		 add(turnLabel);
		 turnLabel.setBounds(155,5,120,40); 
		 } 
	 

     /*public void stop()   {  }*/

     private void drawGrid (Graphics g) {
         g.setColor(Color.black);
         g.drawLine(100,100,450,100);
         g.drawLine(100,150,450,150);
         g.drawLine(100,200,450,200);
         g.drawLine(100,250,450,250);
         g.drawLine(100,300,450,300);
         g.drawLine(100,350,450,350);
         g.drawLine(100,400,450,400);

         g.drawLine(100,100,100,400); 
         g.drawLine(150,100,150,400); 
         g.drawLine(200,100,200,400); 
         g.drawLine(250,100,250,400); 
         g.drawLine(300,100,300,400); 
         g.drawLine(350,100,350,400); 
         g.drawLine(400,100,400,400); 
         g.drawLine(450,100,450,400);         
     }
	
     private void drawX(int col, int row, Graphics g) {
    	 int  xOffset = 105;
    	 int  yOffset = 105;
    	 row = 5-row;
    	 
    	 int xVal = xOffset + (col *50);
    	 int yVal = yOffset + (row * 50);
    	 
         g.drawLine(xVal,yVal,xVal + 40,yVal + 40);
         g.drawLine(xVal,yVal+40,xVal + 40,yVal );
     }
    
     private void drawO(int col, int row, Graphics g) {
    	 int  xOffset = 115;
    	 int  yOffset = 115;
    	 row = 5-row;
    	 
    	 int xVal = xOffset + (col *50);
    	 int yVal = yOffset + (row * 50);
    	 
         g.drawOval(xVal,yVal,20, 20);
     }
     
	private void drawPieces(Graphics g) {
	    for (int i = 0; i < 42; i++) {
	    	int row = i % 6;
	    	int col = i / 6;
	    	if (board[i] == playerX)
	    	   drawX(col,row,g);
	    	else if (board[i] == playerO)
	    		drawO(col,row,g);
	    	
	    }
	}

	private void setPlayerText () {
	       if(currentPlayer == playerX)
	    	   turnLabel.setText("Xs move");
	       else
	    	   turnLabel.setText("Os move");		
	}
	
    private void drawBoard(Graphics g) {
       drawGrid (g);
       drawPieces(g);
       }

     public void paint(Graphics g) 
     { 
      drawBoard(g);
     }  

     //just for playerO before I had the agent class
     /*private void agentMove(int player) {
 		 System.out.println("agent Move");
 		 int result;
 		 int colMove = randomGenerator.nextInt(7);

 		 result = addToBoard(player,colMove);
 		 while (result == 0) {
 	 		 colMove = randomGenerator.nextInt(7);
 	 		 result = addToBoard(player,colMove); 			 
 		 }
 		 currentPlayer = playerX;
     }*/
     
     private void agentMove2(int player) {
 		 System.out.println("agent Move2 " + player);

 		 int colMove;
 		 colMove = playerOAgent.getMove(player);
 		 addToBoard(player,colMove);
 		 
			if (checkForWin())  {
				if (currentPlayer == playerX) {
					System.out.println("X wins");
					turnLabel.setText("X wins;  X starts");
				}
				else { 
					System.out.println("O wins");
					turnLabel.setText("O wins;  X starts");
				}
				repaint();
				return;
			}

 		 if (currentPlayer == playerO )
 		   currentPlayer = playerX;
 		 else  currentPlayer = playerO;
     }
		
    
     //api
     public boolean isValidMove(int move) {
    	 if ((move > 6)  || (move < 0)) return false;
    	 if (piecesInColumn[move] == 6) return false;
    	 return true;
     }
     
     public int[] getBoard() {
    	 return board;
     }
        
     private class connectFourAgent {
  	    private Random randomGenerator;
  	    
    	 public connectFourAgent () {
    	    randomGenerator = new Random();
    	 }
    	 
		public int getMove(int agentNumber) {
			int colMove = randomGenerator.nextInt(7);
			boolean result = false;

			result = isValidMove(colMove);
			while (!result) {
				colMove = randomGenerator.nextInt(7);
				result = isValidMove(colMove);
			}
			return colMove;
		}
    	 
     }
}
